clear
close all
clc

rand('seed',3000);
randn('seed',3000);


img=double(imread('.\Images\slope.png'));

ker=fspecial('gaussian',15,1.5);
tol=1e-4;
sigma=4;
blur=@(f,k)imfilter(f,k,'circular');
og=blur(img,ker);
g=og+sigma*randn(size(img));
frame=1; frame_ini=1;
Level=1; Level_ini=1;
wLevel=1/2;
iterSB=100;
maxiter=20;
tau=0.15; % Threshold for initial index set Gamma
r=0; % size of boundary gamma set removal
mu=0.05; 
lambda=0.2;
% gamma=20*lambda;
gamma=0.5;
shrinktype='vs';

% gext=[rot90(g,2) flipud(g) rot90(g,2); fliplr(g) g fliplr(g); rot90(g,2) flipud(g) rot90(g,2);];
% g=gext(size(g,1)-r+1:2*size(g,1)+r,size(g,2)-r+1:2*size(g,2)+r);

% Initialize jump set Gamma
% Gamma=ones(size(g));
Gamma=InitializeJumpSet(g,frame_ini,Level_ini,tau);
Gamma(1:r,:)=0;Gamma(:,1:r)=0;Gamma(end-r+1:end,:)=0;Gamma(:,end-r+1:end)=0;
% Gamma=bwmorph(Gamma,'thin',3);

figure(1);[I J]=find(Gamma==1);ax(1)=subplot(121);imshow(g,[]);ax(2)=subplot(122);imshow(g,[]);hold on;plot(J,I,'r.');hold off;linkaxes(ax);title(['PSNR = ' num2str(psnr(g/255,img/255)) ', Iter = ' num2str(0)]);

% %=============================================
tic
ut=zeros(size(g));
for Iter=1:maxiter
    u=SplitBregDebP_PS(g,ker,blur,mu,lambda,frame,Level,wLevel,gamma,Gamma,iterSB,img,shrinktype);%imshow(u,[]);
    Gamma=UpdateJumpSet(u,lambda,gamma,frame,Level,wLevel);
    Gamma(1:r,:)=0;Gamma(:,1:r)=0;Gamma(end-r+1:end,:)=0;Gamma(:,end-r+1:end)=0;
    [I J]=find(Gamma==1);figure(1);ax(1)=subplot(121);imshow(g,[]);ax(2)=subplot(122);imshow(u,[]);hold on;plot(J,I,'r.');hold off;linkaxes(ax);title(['PSNR = ' num2str(psnr(u/255,img/255)) ', Iter = ' num2str(Iter)]);
    T=toc;
    error=norm(u-ut,'fro')/norm(g,'fro');ut=u;
    display('======================');
    display(['PSNR at step ' num2str(Iter) ' is: ' num2str(psnr(u/255,img/255)) '; Error = ' num2str(error)]);
    display('======================');
    if error<tol
        break
    end
end
PSNR = psnr(u/255,img/255);
figure(1);ax(1)=subplot(121);imshow(g,[]);ax(2)=subplot(122);imshow(u,[]);linkaxes(ax);title(['PSNR = ' num2str(PSNR) ', Iter = ' num2str(Iter)]);